// Tulsa Sample App.cpp : Application class implementation
//

#include "stdafx.h"
#include <initguid.h>

#include "Tulsa Sample App.h"
#include "MainFrm.h"
#include "Tulsa Sample AppDoc.h"
#include "Tulsa Sample AppView.h"
#include "STBTenum.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

STATUS_UNITS StatusUnits = UNITS_FRAME;	// Current status units
BOOL bAutoView = FALSE;					// TRUE if app should auto cycle thru each card dialog page

GUID tcGuids[MAX_STB_TULSA_CARDS];
DDE_GUIDS ddeGuids;

/////////////////////////////////////////////////////////////////////////////
// CTulsaSampleAppApp
/////////////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(CTulsaSampleAppApp, CWinApp)
	//{{AFX_MSG_MAP(CTulsaSampleAppApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTulsaSampleAppApp construction
/////////////////////////////////////////////////////////////////////////////
CTulsaSampleAppApp::CTulsaSampleAppApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTulsaSampleAppApp object
/////////////////////////////////////////////////////////////////////////////
CTulsaSampleAppApp theApp;


/////////////////////////////////////////////////////////////////////////////
// CTulsaSampleAppApp initialization
/////////////////////////////////////////////////////////////////////////////
BOOL CTulsaSampleAppApp::InitInstance()
{
	SetRegistryKey("STB Systems");	// Make profile settings be read/written from/to registry
#ifdef _AFXDLL
	Enable3dControls();			
#else
	Enable3dControlsStatic();	
#endif
	LoadStdProfileSettings();	
												// Register the application's document templates.  Document templates
												//  serve as the connection between documents, frame windows and views.
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CTulsaSampleAppDoc),
		RUNTIME_CLASS(CMainFrame),       
		RUNTIME_CLASS(CTulsaSampleAppView));
	AddDocTemplate(pDocTemplate);

	CoInitialize(NULL);

	for (int i = 0; i < MAX_STB_TULSA_CARDS; i++)
	{
		tcGuids[i].Data1 = 0;
		ddeGuids.RGBProcGuids[i].Data1 = 0;
		ddeGuids.YUVProcGuids[i].Data1 = 0;
	}
												// Enumerate the available Tulsa Control Objects.
												//  A Control Object GUID will be passed to the 
												//  specified callback routine for each available board.
	StbTulsaControlEnumerate(STCEnumCallback, tcGuids);
												// Enumerate the available Tulsa DirectDraw
												//  Emulation Objects. Two object GUIDs will be 
												//  passed to the specified callback routine for 
												//  each available board.  One object for the 
												//  RGB processor and one for the YUV processor
												//  on each board.
	DirectDrawEmulationEnumerateEx(SDDeEnumCallback, &ddeGuids, 0);

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Cleanup on app exit
/////////////////////////////////////////////////////////////////////////////
int CTulsaSampleAppApp::ExitInstance() 
{
	CoUninitialize();
	return CWinApp::ExitInstance();
}



/////////////////////////////////////////////////////////////////////////////
// Check for error
/////////////////////////////////////////////////////////////////////////////
BOOL HrSUCCEEDED(HRESULT hr)
{
	if (FAILED(hr))
	{
		// get the error info
		IErrorInfo  *pErrInfo;
		hr = GetErrorInfo(0, &pErrInfo);
		if (hr == S_OK)
		{
			WCHAR  *BstrDescription;
			WCHAR  *BstrModule;
			GUID Guid;
			hr = pErrInfo->GetGUID(&Guid);
			hr = pErrInfo->GetDescription((LPWSTR *)&BstrDescription);
			hr = pErrInfo->GetSource((LPWSTR *)&BstrModule);
#ifdef _UNICODE
#else
			char szdescr[120];
			char szmodule[120];
			WideCharToMultiByte(CP_ACP,0, (LPWSTR)BstrDescription, -1, (char *)szdescr, 120, NULL, NULL);
			WideCharToMultiByte(CP_ACP,0, (LPWSTR)BstrModule, -1, (char *)szmodule, 120, NULL, NULL);
#endif
			char szmessage[255];
			wsprintf(szmessage, "%s\n%s", szdescr, szmodule);
			AfxMessageBox(szmessage);
			pErrInfo->Release();
		}
		return FALSE;
	}
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// Called by StbTulsaControlEnumerate for each board in the system
/////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK STCEnumCallback(GUID FAR *lpGUID, LPWSTR lpDriverDescription, LPWSTR lpDriverName, LPVOID lpContext)
{
	GUID	*guids;
	guids = (GUID *)lpContext;
	char szdscr[120];
	char szname[120];
    WideCharToMultiByte(CP_ACP,0,lpDriverDescription,-1, (char *)szdscr, 120, NULL, NULL);
    WideCharToMultiByte(CP_ACP,0,lpDriverName,-1, (char *)szname, 120, NULL, NULL);
	int card = szdscr[strlen(szdscr) - 1] - '0';
	if (card >= 0 && card < MAX_STB_TULSA_CARDS)
		guids[card] = *lpGUID;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Called by DirectDrawEmulationEnumerateEx for each board in the system
/////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK SDDeEnumCallback(GUID FAR *lpGUID, LPWSTR lpDriverDescription, LPWSTR lpDriverName, LPVOID lpContext)
{
	DDE_GUIDS *guids;
	guids = (DDE_GUIDS*)lpContext;
	char szdscr[120];
	char szname[120];
    WideCharToMultiByte(CP_ACP,0,lpDriverDescription,-1, (char *)szdscr, 120, NULL, NULL);
    WideCharToMultiByte(CP_ACP,0,lpDriverName,-1, (char *)szname, 120, NULL, NULL);

	// Should be either "STB DirectDrawEmulation\\RGBProc\\N" or
	//                  "STB DirectDrawEmulation\\YUVProc\\N" where 0 <= N < 4.
	//  RGBProc = RGB graphics processor, YUVProc = YUV video processor

	BOOL bRGBProc = (szdscr[strlen(szdscr) - 9] == 'R')? TRUE: FALSE;
	int card = szdscr[strlen(szdscr) - 1] - '0';
	if (card >= 0 && card < MAX_STB_TULSA_CARDS) {
		if (bRGBProc) {
			guids->RGBProcGuids[card] = *lpGUID;
		} else {
			guids->YUVProcGuids[card] = *lpGUID;
		}
	}
	return TRUE;
}



